apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ wordpress_name }}
    backups.opsperator.io/service: backups-{{ wordpress_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ wordpress_name }}
  name: {{ wordpress_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ wordpress_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ wordpress_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ wordpress_name }}
  strategy:
    recreateParams:
      timeoutSeconds: 1200
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ wordpress_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ wordpress_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ wordpress_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: APACHE_DOMAIN
          value: {{ wordpress_fqdn }}
        - name: APACHE_HTTP_PORT
          value: "8080"
        - name: AUTH_METHOD
{% if do_lemon %}
          value: lemon
{% elif do_ldap %}
          value: ldap
{% else %}
          value: none
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
{% if do_ldap and do_lemon %}
        - name: LEMON_PROTO
          value: {{ lemon_portal | urlsplit('scheme') }}
        - name: LLNG_SSO_DOMAIN
          value: {{ lemon_portal | urlsplit('hostname') }}
{% else %}
        - name: LEMON_PROTO
          value: ""
        - name: LLNG_SSO_DOMAIN
          value: ""
{% endif %}
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=wordpress,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: wordpress-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: PHP_MAX_EXECUTION_TIME
          value: "{{ wordpress_php_max_execution_time }}"
        - name: PHP_MEMORY_LIMIT
          value: {{ wordpress_php_memory_limit }}
        - name: PUBLIC_PROTO
          value: https
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_PROTO
          value: smtp
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_PROTO
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
        - name: WORDPRESS_ADMIN_PASS
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ wordpress_name }}
        - name: WORDPRESS_ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ wordpress_name }}
        - name: WORDPRESS_SERVER_NAME
          value: {{ wordpress_fqdn }}
        - name: WORDPRESS_AUTH_KEY
          valueFrom:
            secretKeyRef:
              key: auth-key
              name: {{ wordpress_name }}
        - name: WORDPRESS_AUTH_SALT
          valueFrom:
            secretKeyRef:
              key: auth-salt
              name: {{ wordpress_name }}
{% if wordpress_db_type in [ 'mariadb', 'mysql' ] %}
        - name: WORDPRESS_DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ wpms_name }}
        - name: WORDPRESS_DB_HOST
          value: {{ wpms_name }}
        - name: WORDPRESS_DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ wpms_name }}
        - name: WORDPRESS_DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ wpms_name }}
{% elif wordpress_db_type == 'percona' %}
        - name: WORDPRESS_DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ wppc_name }}
        - name: WORDPRESS_DB_HOST
          value: {{ wppc_name }}-client
        - name: WORDPRESS_DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ wppc_name }}
        - name: WORDPRESS_DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ wppc_name }}
{% endif %}
        - name: WORDPRESS_LOGGED_IN_KEY
          valueFrom:
            secretKeyRef:
              key: logged-in-key
              name: {{ wordpress_name }}
        - name: WORDPRESS_LOGGED_IN_SALT
          valueFrom:
            secretKeyRef:
              key: logged-in-salt
              name: {{ wordpress_name }}
        - name: WORDPRESS_NONCE_KEY
          valueFrom:
            secretKeyRef:
              key: nonce-key
              name: {{ wordpress_name }}
        - name: WORDPRESS_NONCE_SALT
          valueFrom:
            secretKeyRef:
              key: nonce-salt
              name: {{ wordpress_name }}
        - name: WORDPRESS_SECURE_AUTH_KEY
          valueFrom:
            secretKeyRef:
              key: secure-auth-key
              name: {{ wordpress_name }}
        - name: WORDPRESS_SECURE_AUTH_SALT
          valueFrom:
            secretKeyRef:
              key: secure-auth-salt
              name: {{ wordpress_name }}
{% if do_triggers == False or (opsimages | json_query("[?name=='wordpress'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='wordpress'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 39
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            httpHeaders:
            - name: Host
              value: localhost
            path: /
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 30
          timeoutSeconds: 8
        name: wordpress
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
              value: localhost
            path: /
            port: 8080
          initialDelaySeconds: 15
          periodSeconds: 5
          timeoutSeconds: 4
        resources:
          limits:
            cpu: "{{ wordpress_cpu_limit }}"
            memory: "{{ wordpress_memory_limit }}"
          requests:
            cpu: "{{ wordpress_cpu_request }}"
            memory: "{{ wordpress_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 39
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
        - mountPath: /.wp-cli
          name: run
          subPath: wpcli
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: run
          subPath: apache
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /usr/local/share/ca-certificates
          name: run
          subPath: ca-certificates
        - mountPath: /var/www/html
          name: blog
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 39
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 30
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 39
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 9113
{% endif %}
{% endif %}
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: run
          subPath: bkphome
        - mountPath: /var/backup
          name: run
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: blog
{% endif %}
{% if do_exporters %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if (rwx_storage | default(False) and rwx_needs_fsgroup | default(False)) or (rwx_storage is not defined and rwo_needs_fsgroup | default(False)) %}
      securityContext:
{% if rwx_storage | default(False) and rwx_needs_fsgroup | default(False) %}
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif rwx_storage is not defined and rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ wordpress_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: blog
        persistentVolumeClaim:
          claimName: {{ wordpress_name }}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
      - emptyDir: {}
        name: run
{% if do_backups %}
      - name: ssh
        secret:
          secretName: backups-{{ wordpress_name }}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='wordpress'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - wordpress
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='wordpress'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
    type: ImageChange
{% endif %}
  - type: ConfigChange
{% endif %}
